package gus05.entity.gus.app.action.about.darkpanel2;


import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.Date;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;



class AboutPanel extends JPanel {
	
	public static Border b_empty8888 = BorderFactory.createEmptyBorder(8,8,8,8);
	
	private Map prop;
	private Color current_foreground = Color.BLACK;
    
	
    public AboutPanel(Map prop, Icon iconGus05, String managerID, JLabel webLabel, JLabel mailLabel) throws Exception
    {
    	super(new GridBagLayout());
    	this.prop = prop;
    	
    	String appName = prop("app.name");
        String appTitle = prop("app.title");
        String appVersion = prop("app.version");
        String appBuild = prop("app.build");
        String appGus05ID = prop("app.gus05id");
        String appFirstBuild = prop("app.firstbuild");
        String appAuthorName = prop("app.author.name");
        String appAuthorEmail = prop("app.author.email");
        String urlAuthorWebsite = prop("app.author.website");
        
        String age1 = age_str(appFirstBuild);
        long age2 = age(appBuild);
        
        
        
        
        current_foreground = TOOL.randomColor();
        JLabel label_appTitle = 	labelBold(18,appTitle);
        JLabel label_appBuild = 	labelBold(15,"version "+appVersion+" build "+appBuild);
        
        JLabel label_author = 		label(12,"application created by "+appAuthorName);
        JLabel label_email = 		label(12,appAuthorEmail,mailLabel);
        
        JLabel label_icon = new JLabel(iconGus05);
        
        JLabel label_appName = 		label(9,"app name: "+appName);
        JLabel label_appID =	 	label(9,"app ID: "+appGus05ID);
        JLabel label_managerID = 	label(9,"manager ID: "+managerID);
        JLabel label_appAge = 		label(9,"app age: "+age1+" ("+age2+")");
        
        current_foreground = Color.LIGHT_GRAY;
        JLabel label_framework = 	label(9,TOOL.gus05_copyright());
        JLabel label_website = 		label(9,urlAuthorWebsite,webLabel);
        
        
        

        add(new JLabel(" "), nextConstraints());
        add(label_appTitle, nextConstraints());
        add(label_appBuild, nextConstraints());
        add(new JLabel(" "), nextConstraints());
        add(label_author, nextConstraints());
        add(label_email, nextConstraints());
        add(new JLabel(" "), nextConstraints());
        
        add(new JLabel(" "), nextConstraints());
        add(label_appName, nextConstraints());
        add(label_managerID, nextConstraints());
        add(label_appID, nextConstraints());
        add(label_appAge, nextConstraints());
        add(new JLabel(" "), nextConstraints());
        
        add(label(9," "), nextConstraints());
        add(label_icon, nextConstraints());
        add(label(9," "), nextConstraints());
        add(label_framework, nextConstraints());
        add(label_website, nextConstraints());
        add(label(9," "), nextConstraints());
        
        setOpaque(true);
        setBorder(b_empty8888);
        setBackground(Color.WHITE);
    }
    
    
    
    
    
    
    
    
    
    private String prop(String key)
    {
    	if(prop.containsKey(key)) return (String) prop.get(key);
    	return "?";
    }
    
    
    
    
    
    
    private String age_str(String timeStamp) throws Exception
    {
    	long age = age(timeStamp);
        return age>1?age+" days":age+" day";
    }
    
    private long age(String timeStamp) throws Exception
    {
    	if(timeStamp.equals("?")) return -1;
    	Date date = TOOL.yyyyMMdd.parse(timeStamp);
        return TOOL.daysFrom(date);
    }
    
    
    
    
    private JLabel label(int size, String text)
    {
    	JLabel label = new JLabel(text);
    	label.setFont(new Font("dialog", Font.PLAIN, size));
    	label.setForeground(current_foreground);
    	return label;
    }
    
    
    private JLabel label(int size, String text, JLabel label)
    {
    	label.setText(text);
    	label.setFont(new Font("dialog", Font.PLAIN, size));
    	label.setForeground(current_foreground);
    	return label;
    }
    
    
    private JLabel labelBold(int size, String text)
    {
    	JLabel label = new JLabel(text);
    	label.setFont(new Font("dialog", Font.BOLD, size));
    	label.setForeground(current_foreground);
    	return label;
    }
    
    
    
    
    
    
    
    
    int n=0;
    
    private GridBagConstraints nextConstraints()
    {return createConstraints(1,n++);}
    
    private GridBagConstraints createConstraints(int x, int y)
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.anchor = GridBagConstraints.CENTER;
        c.weightx = 0.0;
        c.weighty = 0.0;
        return c;
    }
}
