package gus05.entity.gus.app.action.mailto.appfeedback;


import java.util.Map;

import javax.swing.Action;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Execute;
import gus05.framework.resources.ActionBuilder;



public class MailToAppFeedback implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.mailto.appfeedback";}
    public String getCreationDate()		{return "2009.02.03";}



    private Service mailTo;
    
    private ActionBuilder actionBuilder;
    private Map prop;
    
    private Action action;
    private String addressMail;
    private String appID;
    
    
    
    public MailToAppFeedback() throws Exception
    {
    	mailTo = Outside.service(this,"gus.env.all.command.mailto");
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
    	prop = (Map) Outside.resource(this,"app.prop.map");
    	
    	appID = prop("app.gus05id");
    	addressMail = prop("app.author.email");
    	
    	action = actionBuilder.build("UTIL_mailTo",this);
    }



    public void execute() throws Exception
    {
    	String subject = "FEEDBACK for gus05 application: id="+appID;
    	String info = addressMail+"?subject="+subject;
    	mailTo.give(info);
    }



    public Object provide() throws Exception
    {return action;}


    
    private String prop(String key)
    {
    	if(prop.containsKey(key)) return (String) prop.get(key);
    	return "?";
    }
}

