package gus05.entity.gus.app.running.unicitycontrol;


import java.io.File;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;



public class UnicityControl implements Entity {


    public String getName()				{return "gus.app.running.unicitycontrol";}
    public String getCreationDate()		{return "2008.11.22";}

    public static final long DELAY = 500;

    private Service executeExit;
    
    private Timer timer;
    private TimerTask task1;
    private TimerTask task2;
    
    private File ctrFile;
    private boolean initial;
    
    
    
    
    public UnicityControl() throws Exception
    {
    	executeExit = Outside.service(this,"app.executeexit");
    	
    	File tmpDir = (File) Outside.resource(this,"defaultdir");
    	ctrFile = new File(tmpDir,"ctr");
    	initial = ctrFile.exists();
    	
    	task1 = new TimerTask(){public void run() {check();}};
    	task2 = new TimerTask(){public void run() {change();}};
    	
    	timer = new Timer();
    	timer.schedule(task1,DELAY);
    }
    
    
    
    
    private void check()
    {
    	boolean r = ctrFile.exists();
    	if(r!=initial) exit();
    	
    	timer.schedule(task2,new Date(),DELAY);
    }
    
    
    
    
    
    
    private void change()
    {
    	boolean r = ctrFile.exists();
    	if(r) delete();
    	else create();
    }
    
    private void create()
    {
    	try{ctrFile.createNewFile();}
    	catch(Exception e){}
    }
    
    private void delete()
    {
    	ctrFile.delete();
    }

    
    
    
    
    
    
    private void exit()
    {
    	try{executeExit.execute();}
    	catch(Exception e)
    	{Outside.err(this,"exit()",e);}
    }
}

