package gus05.entity.gus.collection.map.transform.filteringmap1;


import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Transform;
import gus05.framework.features.Register;



public class FilteringMap1 implements Entity, Transform, Register {


    public String getName()				{return "gus.collection.map.transform.filteringmap1";}
    public String getCreationDate()		{return "2009.02.27";}


    
    private Service filterRule;
    
    private String fieldInfo;
    private String valueInfo;
    
    private boolean fieldInfoIgnored = false;
    private boolean valueInfoIgnored = false;
    
    private Filter fieldInfoFilter;
    private Filter valueInfoFilter;
    


    public FilteringMap1() throws Exception
    {
    	filterRule = Outside.service(this,"gus.filter.string.build.rule1");
    }
    
    private Filter buildFilter(String rule) throws Exception
    {return (Filter) filterRule.transform(rule);}



    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("info"))
    	{initInfo((String[]) obj);return;}
    	
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    
    private void initInfo(String[] info) throws Exception
    {
    	if(info.length!=2) throw new Exception("Wrong info number: "+info.length);
		fieldInfo = info[0];
		valueInfo = info[1];
		
		fieldInfoIgnored = fieldInfo.startsWith("ignore:");
		valueInfoIgnored = valueInfo.startsWith("ignore:");
		
		fieldInfoFilter = fieldInfoIgnored?null:buildFilter(fieldInfo);
		valueInfoFilter = valueInfoIgnored?null:buildFilter(valueInfo);
    }
    
    
    



    public Object transform(Object obj) throws Exception
    {
    	if(fieldInfo==null) throw new Exception("Info field has not been initialized yet");
    	if(valueInfo==null) throw new Exception("Info value has not been initialized yet");
    	
    	Map map = (Map) obj;
    	Properties p = new Properties();
    	Iterator it = map.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		String value = (String) map.get(key);
    		
    		if(keep(key,value))
    		p.setProperty(key, value);
    	}
    	return p;
    }


    
    private boolean keep(String key, String value) throws Exception
    {
    	if(!fieldInfoIgnored && !fieldInfoFilter.filter(key)) return false;
    	if(!valueInfoIgnored && !valueInfoFilter.filter(value)) return false;
    	return true;
    }
}

