package gus05.entity.gus.filter.string.build.endswith_n;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Transform;



public class FilterEndsWith_n implements Entity, Transform {


    public String getName()				{return "gus.filter.string.build.endswith_n";}
    public String getCreationDate()		{return "2008.06.16";}


    private Service charNormalize;
    
    public FilterEndsWith_n() throws Exception
    {charNormalize = Outside.service(this,"gus.stringtransform.character.lowercasenormalize");}


    private String normalize(String s) throws Exception
    {return (String) charNormalize.transform(s);}

    
    public Object transform(Object obj) throws Exception
    {
        String s = normalize((String)obj);
        return new Filter_endsWith(s);
    }
    
    
    private class Filter_endsWith implements Filter
    {
        private String value;
        public Filter_endsWith(String value)
        {this.value = value;}
        
        public boolean filter(Object obj) throws Exception
        {
            String str = normalize((String)obj);
            return str.endsWith(value);
        }
    }
}

