package gus05.entity.gus.filter.string.build.equals_n;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Transform;



public class FilterEquals_n implements Entity, Transform {


    public String getName()				{return "gus.filter.string.build.equals_n";}
    public String getCreationDate()		{return "2008.08.03";}


    private Service charNormalize;
    
    public FilterEquals_n() throws Exception
    {charNormalize = Outside.service(this,"gus.stringtransform.character.lowercasenormalize");}


    private String normalize(String s) throws Exception
    {return (String) charNormalize.transform(s);}

    
    public Object transform(Object obj) throws Exception
    {
        String s = normalize((String)obj);
        return new Filter_equals(s);
    }
    
    
    private class Filter_equals implements Filter
    {
        private String value;
        public Filter_equals(String value)
        {this.value = value;}
        
        public boolean filter(Object obj) throws Exception
        {
            String str = normalize((String)obj);
            return str.equals(value);
        }
    }
}

