package gus05.entity.gus.filter.string.build.rule1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Transform;



public class FilterRule1 implements Entity, Transform {


    public String getName()				{return "gus.filter.string.build.rule1";}
    public String getCreationDate()		{return "2008.10.03";}


    
    private Service filter_equals;
    private Service filter_equals_i;
    private Service filter_equals_n;
    
    private Service filter_startswith;
    private Service filter_startswith_i;
    private Service filter_startswith_n;
    
    private Service filter_endswith;
    private Service filter_endswith_i;
    private Service filter_endswith_n;

    private Service filter_contains;
    private Service filter_contains_i;
    private Service filter_contains_n;
    
    private Service filter_allofthem;
    private Service filter_allofthem_i;
    private Service filter_allofthem_n;
    
    private Service filter_oneofthem;
    private Service filter_oneofthem_i;
    private Service filter_oneofthem_n;
    
    
    
    
    
    public FilterRule1() throws Exception
    {
    	filter_equals = Outside.service(this,"gus.filter.string.build.equals");
    	filter_equals_i = Outside.service(this,"gus.filter.string.build.equals_i");
    	filter_equals_n = Outside.service(this,"gus.filter.string.build.equals_n");
    	
    	filter_startswith = Outside.service(this,"gus.filter.string.build.startswith");
    	filter_startswith_i = Outside.service(this,"gus.filter.string.build.startswith_i");
    	filter_startswith_n = Outside.service(this,"gus.filter.string.build.startswith_n");
    	
    	filter_endswith = Outside.service(this,"gus.filter.string.build.endswith");
    	filter_endswith_i = Outside.service(this,"gus.filter.string.build.endswith_i");
    	filter_endswith_n = Outside.service(this,"gus.filter.string.build.endswith_n");

    	filter_contains = Outside.service(this,"gus.filter.string.build.contains");
    	filter_contains_i = Outside.service(this,"gus.filter.string.build.contains_i");
    	filter_contains_n = Outside.service(this,"gus.filter.string.build.contains_n");
    	
    	filter_allofthem = Outside.service(this,"gus.filter.string.build.allofthem");
    	filter_allofthem_i = Outside.service(this,"gus.filter.string.build.allofthem_i");
    	filter_allofthem_n = Outside.service(this,"gus.filter.string.build.allofthem_n");

    	filter_oneofthem = Outside.service(this,"gus.filter.string.build.oneofthem");
    	filter_oneofthem_i = Outside.service(this,"gus.filter.string.build.oneofthem_i");
    	filter_oneofthem_n = Outside.service(this,"gus.filter.string.build.oneofthem_n");
    }
    
    
    public Object transform(Object obj) throws Exception
    {
        String rule = (String)obj;
        String[] n = rule.split(":",2);
        
        if(n[0].equals("eq")) return filter_equals.transform(n[1]);
        if(n[0].equals("eq_i")) return filter_equals_i.transform(n[1]);
        if(n[0].equals("eq_n")) return filter_equals_n.transform(n[1]);
        
        if(n[0].equals("st")) return filter_startswith.transform(n[1]);
        if(n[0].equals("st_i")) return filter_startswith_i.transform(n[1]);
        if(n[0].equals("st_n")) return filter_startswith_n.transform(n[1]);
        
        if(n[0].equals("en")) return filter_endswith.transform(n[1]);
        if(n[0].equals("en_i")) return filter_endswith_i.transform(n[1]);
        if(n[0].equals("en_n")) return filter_endswith_n.transform(n[1]);
        
        if(n[0].equals("co")) return filter_contains.transform(n[1]);
        if(n[0].equals("co_i")) return filter_contains_i.transform(n[1]);
        if(n[0].equals("co_n")) return filter_contains_n.transform(n[1]);
        
        if(n[0].equals("aothem")) return filter_allofthem.transform(n[1]);
        if(n[0].equals("aothem_i")) return filter_allofthem_i.transform(n[1]);
        if(n[0].equals("aothem_n")) return filter_allofthem_n.transform(n[1]);
        
        if(n[0].equals("oothem")) return filter_oneofthem.transform(n[1]);
        if(n[0].equals("oothem_i")) return filter_oneofthem_i.transform(n[1]);
        if(n[0].equals("oothem_n")) return filter_oneofthem_n.transform(n[1]);
        
        if(n[0].equals("all")) return ALL;
        if(n[0].equals("none")) return NONE;
        
        throw new Exception("Invalid rule: "+rule);
    }
    
    
    
    public final static Filter ALL = new Filter(){public boolean filter(Object obj) throws Exception {return true;}};
    public final static Filter NONE = new Filter(){public boolean filter(Object obj) throws Exception {return false;}};
    
}

