package gus05.entity.gus.graphic.table.rendering0;


import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Register;
import gus05.framework.resources.IconProvider;



public class TableRendering0 implements Entity, Register {


    public String getName()				{return "gus.graphic.table.rendering0";}
    public String getCreationDate()		{return "2009.02.15";}

    
    private Color color = Color.GREEN;
    
    private IconProvider iconProvider;
    
    private Icon icon(String key)
    {return iconProvider.getIcon(key);}
    

    public TableRendering0() throws Exception
    {iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");}



    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("color")) {color = (Color)obj;return;}
        
        JTable table = (JTable)obj;
        String[] ids = key.split(";");
        
        table.setDefaultRenderer(Object.class,new TableRenderer0(ids,color));
    }


    
    
    
    private class TableRenderer0 extends JLabel implements TableCellRenderer
    {
        private Font plain_font;
        private Font bold_font;
        
        private String[] ids;
        private Color c;
        
        public TableRenderer0(String[] ids, Color c)
        {
            setOpaque(true);
            this.ids = ids;
            this.c = c;
            
            plain_font = getFont().deriveFont(Font.PLAIN);
            bold_font = getFont().deriveFont(Font.BOLD);
            
            setFont(plain_font);
            setBackground(Color.WHITE);
        }

        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row,int column)
		{
            if(isSelected)
            {
                setFont(bold_font);
                setForeground(c);
            }
            else
            {
                setFont(plain_font);
                setForeground(Color.BLACK);
            }
            
            setText(value.toString());
            setIcon(findIcon(ids,column));
            return this;
        }
    }
    
    
    
    
    private Icon findIcon(String[] ids, int column)
    {
    	if(ids.length<=column) return null;
    	String value = ids[column];
    	if(value.equals("")) return null;
    	return icon(value);
    }
}

