package gus05.entity.gus.graphic.textcomp.buildgui.panel1;


import java.awt.BorderLayout;
import java.awt.event.ActionListener;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Support;
import gus05.framework.features.Transform;



public class TextCompPanel1 implements Entity, Transform {


    public String getName()				{return "gus.graphic.textcomp.buildgui.panel1";}
    public String getCreationDate()		{return "2006.10.06";}


    private Service actionSet;
    private Service highlightSupport;
    private Service scrollBarHighlight;
    private Service countHighlight;
    

    public TextCompPanel1() throws Exception
    {
        actionSet = Outside.service(this,"gus.graphic.textcomp.action.set1");
        highlightSupport = Outside.service(this,"gus.graphic.textcomp.highlight.support");
        scrollBarHighlight = Outside.service(this,"gus.graphic.textcomp.highlight.scrollbar");
        countHighlight = Outside.service(this,"gus.graphic.textcomp.highlight.count");
    }



    public Object transform(Object obj) throws Exception
    {
        JTextComponent comp = (JTextComponent)obj;
        JScrollPane scroll = new JScrollPane(comp);
        JComponent countComp = new JLabel();
        
        
        if(comp instanceof JTextArea)
        {
            Support support = (Support)highlightSupport.transform(comp);
            ActionListener listener1 = (ActionListener)scrollBarHighlight.transform(scroll);
            countComp = (JComponent) countHighlight.transform(comp);
            ActionListener listener2 = (ActionListener)countComp;
            
            support.addActionListener(listener1);
            support.addActionListener(listener2);
        }
        
        actionSet.give(comp);
        
        JPanel panel = new JPanel(new BorderLayout());
        panel.add(scroll,BorderLayout.CENTER);
        panel.add(countComp,BorderLayout.SOUTH);
        
        return panel;
    }


}

