/*
 * Created on 20 fvr. 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.entity.gus.graphic.textcomp.highlight.count;


import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.JLabel;
import javax.swing.JToolBar;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.DocumentEvent;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;


public class JToolBarCounter extends JToolBar implements MouseMotionListener, CaretListener, ActionListener {

    
    private JTextComponent comp;
    private HashMap map;
    

    public JToolBarCounter(JTextComponent comp) throws Exception
    {
        super();
        setFloatable(false);
        
        this.comp = comp;
        map = new HashMap();
    }

    
    
    private void update()
    {
        map.clear();
        removeAll();
        
        Highlighter.Highlight[] ht = comp.getHighlighter().getHighlights();
        
        for(int i=0;i<ht.length;i++)
        {
            DefaultHighlighter.DefaultHighlightPainter painter = 
                (DefaultHighlighter.DefaultHighlightPainter)ht[i].getPainter();
            addColor(painter.getColor());
        }
        
        Iterator it = map.keySet().iterator();
        while(it.hasNext())
        {
            Color c = (Color)it.next();
            Integer n = (Integer)map.get(c);
            JLabel label = new JLabel(" "+n);
            label.setForeground(c);
            label.setToolTipText("r="+c.getRed()+" ,g="+c.getGreen()+",b="+c.getBlue());
            
            add(label);
        }
        revalidate();
        repaint();
    }
    
    
    
    private void addColor(Color color)
    {
        if(color==null) color = comp.getSelectionColor();
        
        if(!map.containsKey(color))
            map.put(color,new Integer(1));
        else
        {
            Integer n = (Integer)map.get(color);
            map.put(color,new Integer(n.intValue()+1));
        }   
    }
    
    
    
    public void insertUpdate(DocumentEvent e) {update();}
    public void removeUpdate(DocumentEvent e) {update();}
    public void changedUpdate(DocumentEvent e) {update();}
    public void actionPerformed(ActionEvent e) {update();}
    public void caretUpdate(CaretEvent e) {update();}
    public void mouseDragged(MouseEvent e) {update();}
    public void mouseMoved(MouseEvent e) {}
}
