package gus05.entity.gus.graphic.textcomp.popupmenu1;


import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.util.List;

import javax.swing.Action;
import javax.swing.JPopupMenu;
import javax.swing.text.JTextComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.resources.ActionBuilder;



public class PopupMenu1 implements Entity, Give {


    public String getName()				{return "gus.graphic.textcomp.popupmenu1";}
    public String getCreationDate()		{return "2007.02.18";}


    private Service resourceCall;
    private ActionBuilder actionBuilder;
    private List configList;
    private JPopupMenu popupMenu;

    
    public PopupMenu1() throws Exception
    {
        resourceCall = Outside.service(this,"app.entity.resourcecall");
        actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        configList = (List) Outside.resource(this,"configList");
    }



    public void give(Object obj) throws Exception
    {
        JTextComponent comp = (JTextComponent) obj;
        
        JPopupMenu popupMenu = new JPopupMenu();
        for(int i=0;i<configList.size();i++)
        {
            String info = (String) configList.get(i);
            if(!info.equals("") && !info.startsWith("#"))
            {
                if(info.equals("separator")) popupMenu.addSeparator();
                else popupMenu.add(buildAction(info,comp));
            }
        }
        comp.addMouseListener(new PopupAdapter(popupMenu));
    }
    
    
    
    
    private Action buildAction(String info, JTextComponent comp)
    {
        try
        {
            String[] n = info.split("#",2);
            String actionID = n[0];
            Object element = resourceCall.transform(n[1]);
            if(element instanceof Action) return (Action) element;
            
            Execute execute = buildExecute(element,comp);
            return actionBuilder.build(actionID,execute);
        }
        catch(Exception e)
        {Outside.err(this,"buildAction(String,JTextComponent)",e);}
        return null;
    }
    
    
    private Execute buildExecute(Object element, JTextComponent comp) throws Exception
    {
        if(element instanceof Give) return new Execute0((Give)element,comp);
        if(element instanceof Execute) return (Execute) element;
        
        throw new Exception("Invalid type: "+element.getClass().getName());
    }
    
    
    
    
    private class Execute0 implements Execute
    {
        private JTextComponent comp;
        private Give give;
        
        public Execute0(Give give, JTextComponent comp)
        {
            this.give = give;
            this.comp = comp;
        }
        public void execute() throws Exception
        {give.give(comp.getSelectedText());}
    }
    
    
    
    
    
    
    
    private class PopupAdapter extends MouseAdapter
    {
        private JPopupMenu popup;
        public PopupAdapter(JPopupMenu popup) 
        {this.popup = popup;}
        
        public void mousePressed(MouseEvent e) {maybeShowPopup(e);}
        public void mouseReleased(MouseEvent e) {maybeShowPopup(e);}
        
        private void maybeShowPopup(MouseEvent e)
        {
            if(e.isPopupTrigger())
            popup.show(e.getComponent(),e.getX(),e.getY());
        }
    }


}

