package gus05.entity.gus.java.jarinspector.app1.maingui1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.border.BevelBorder;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;



public class JarInspectorMainGui implements Entity, Graphic, Runnable {


    public String getName()				{return "gus.java.jarinspector.app1.maingui1";}
    public String getCreationDate()		{return "2009.02.26";}


    private Service onlineLabel;
    
    private Service queryGui;
    private Service resultGui;
    private Service engine;
    
    private Icon iconButton;
    
    private JToggleButton button;
    private JLabel labelCurrentScan;
    private JPanel panel;
    
    private JTextArea areaResult;
    private JLabel labelResultNumber;
    

    private boolean running = false;
    private int resultNumber = 0;



    public JarInspectorMainGui() throws Exception
    {
    	onlineLabel = Outside.service(this,"gus.watching.online.label");
    	
    	queryGui = Outside.service(this,"gus.java.jarinspector.app1.querygui");
    	resultGui = Outside.service(this,"gus.java.jarinspector.app1.resultgui");
    	engine = Outside.service(this,"gus.java.jarinspector.app1.engine");
        
    	iconButton = (Icon) Outside.resource(this,"icon#loupe3");
    	
    	button = new JToggleButton("perform search");
    	button.setIcon(iconButton);
    	button.setBorder(new OvalBorder());
    	button.addActionListener(new ActionListener(){
    		public void actionPerformed(ActionEvent e) {performSearch();}
    	});
    	
    	
    	labelResultNumber = new JLabel(" ");
    	labelResultNumber.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
    	
    	labelCurrentScan = (JLabel) engine.retrieve("label_currentScan");
    	labelCurrentScan.setFont(labelCurrentScan.getFont().deriveFont(Font.ITALIC));
    	
    	areaResult = new JTextArea();
    	areaResult.setEditable(false);
    	
    	JTabbedPane tab = new JTabbedPane();
    	tab.addTab("table display", resultGui.gui());
    	tab.addTab("text display", new JScrollPane(areaResult));
    	
    	JPanel p_center = new JPanel(new BorderLayout());
    	p_center.add(queryGui.gui(),BorderLayout.NORTH);
    	p_center.add(tab,BorderLayout.CENTER);
    	p_center.add(labelResultNumber,BorderLayout.SOUTH);
    	
    	panel = new JPanel(new BorderLayout());
    	panel.add(button,BorderLayout.NORTH);
        panel.add(p_center,BorderLayout.CENTER);
        panel.add(bottom_p(),BorderLayout.SOUTH);
        
        engine.addActionListener(new ActionListener(){
    		public void actionPerformed(ActionEvent e) {resultFound();}
    	});
    }



    public JComponent gui()
    {return panel;}


    
    
    
    
    private JPanel bottom_p()
    {
    	JToolBar bar = new JToolBar();
    	bar.setFloatable(false);
    	
    	bar.add(onlineLabel.gui());
    	bar.addSeparator();
    	
    	JPanel p = new JPanel(new BorderLayout());
    	p.add(bar,BorderLayout.EAST);
    	p.add(labelCurrentScan,BorderLayout.CENTER);
    	return p;
    }
    
    
    
    
    private void resultFound()
    {
    	try
		{
    		String line = (String) engine.provide();
    		areaResult.append(line+"\n");
    		resultGui.give(line);
    		
    		resultNumber++;
    		labelResultNumber.setText(" Result number : "+resultNumber+" (processing)");
		}
    	catch(Exception e)
		{Outside.err(this,"resultFound()",e);}
    }
	
	
	
	
	private void performSearch()
	{
		try
		{
			if(running)
			{
				interruptSearch();
				return;
			}
			running = true;
			button.setSelected(true);
			button.setText("interrupt search");
			
			File scanDir = (File) queryGui.retrieve("scanDir");
			String entryInfo = (String) queryGui.retrieve("query_entry");
			String fieldInfo = (String) queryGui.retrieve("query_field");
			String valueInfo = (String) queryGui.retrieve("query_value");
			
			engine.register("scanDir", scanDir);
			engine.register("entryInfo", entryInfo);
			engine.register("fieldInfo", fieldInfo);
			engine.register("valueInfo", valueInfo);
			
			areaResult.setText("");
			resultGui.execute();
			resultNumber = 0;
			labelResultNumber.setText(" Result number : "+resultNumber+" (processing)");
			
			new Thread(this).start();
		}
		catch(Exception e)
		{Outside.err(this,"performSearch()",e);}
	}
	
	
	
	
	private void interruptSearch()
	{
		try
		{
			engine.register("stop",null);
			searchOver();
		}
		catch(Exception e)
		{Outside.err(this,"interruptSearch()",e);}
	}
	
	
	
	public void run()
	{
		engine.run();
		searchOver();
	}
	
	
	private void searchOver()
	{
		button.setSelected(false);
		button.setText("perform search");
		labelResultNumber.setText(" Result number : "+resultNumber);
		running = false;
	}
	
}

