package gus05.entity.gus.java.jarinspector.app1.querygui;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Graphic;
import gus05.framework.features.Retrieve;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import java.awt.BorderLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Vector;



public class QueryGui implements Entity, Graphic, Retrieve {


    public String getName()				{return "gus.java.jarinspector.app1.querygui";}
    public String getCreationDate()		{return "2009.02.27";}


    private Service form;
    private Service input_dirLabel;
    private Service persistGui;
    private Service persistFile;
    
    private JPanel panel;
    
    private StringJComboBox comboBox_entry;
    private StringJComboBox comboBox_field;
    private StringJComboBox comboBox_value;
    
    private JTextField textField_entry;
    private JTextField textField_field;
    private JTextField textField_value;
    
    private JRadioButtonBold radio_ignoreCase1;
    private JRadioButtonBold radio_ignoreCase2;
    
    private Vector list_choiceDisplays;
    private Vector list_choiceCodes;
    




    public QueryGui() throws Exception
    {
    	form = Outside.service(this,"gus.graphic.panel.form1");
    	input_dirLabel = Outside.service(this,"gus.file.label.load.dirlabel");
    	persistGui = Outside.service(this,"gus.graphic.persistence.persistence1");
    	persistFile = Outside.service(this,"gus.persistence.fileholder");
    	
    	list_choiceDisplays = new Vector();
    	list_choiceCodes = new Vector();
    	
    	init("ignore","ignore");
    	init("equals","eq");
    	init("contains","co");
    	init("starts with","st");
    	init("ends with","en");
    	init("all of them","aothem");
    	init("one of them","oothem");
    	
    	
    	comboBox_entry = new StringJComboBox(list_choiceDisplays);
    	comboBox_field = new StringJComboBox(list_choiceDisplays);
    	comboBox_value = new StringJComboBox(list_choiceDisplays);
    	
    	textField_entry = new JTextField();
    	textField_field = new JTextField();
    	textField_value = new JTextField();
    	
    	radio_ignoreCase1 = new JRadioButtonBold("ignore case",false);
    	radio_ignoreCase2 = new JRadioButtonBold("ignore case and diacritics",false);
    	
    	
    	persistGui.register(getName()+"_combo1",comboBox_entry);
    	persistGui.register(getName()+"_combo2",comboBox_field);
    	persistGui.register(getName()+"_combo3",comboBox_value);
    	
    	persistGui.register(getName()+"_text1",textField_entry);
    	persistGui.register(getName()+"_text2",textField_field);
    	persistGui.register(getName()+"_text3",textField_value);
    	
    	persistGui.register(getName()+"_radio1",radio_ignoreCase1);
    	persistGui.register(getName()+"_radio2",radio_ignoreCase2);
    	
    	persistFile.register(getName()+"_dir",input_dirLabel);
    	
    	
    	
    	form.register(" Scanned folder ",input_dirLabel.gui());
    	form.register(" ",new JLabel(" "));
    	form.register(" Searched entry ",wc(comboBox_entry,textField_entry));
    	form.register(" Searched field ",wc(comboBox_field,textField_field));
    	form.register(" Searched value ",wc(comboBox_value,textField_value));
    	form.register(" Search options ",wc(radio_ignoreCase1,radio_ignoreCase2));
    	
        panel = new JPanel(new BorderLayout());
        panel.add(form.gui(),BorderLayout.CENTER);
        
        Border emptyBorder = BorderFactory.createEmptyBorder(5,5,5,5);
    	Border raisedBorder = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    	Border b1 = BorderFactory.createCompoundBorder(emptyBorder, raisedBorder);
    	Border b2 = BorderFactory.createCompoundBorder(b1, emptyBorder);
    	
    	panel.setBorder(b2);
    	
    	
    	comboBox_entry.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e)
			{textField_entry.setEnabled(comboBox_entry.getSelectedIndex()>0);}
		});
    	comboBox_field.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e)
			{textField_field.setEnabled(comboBox_field.getSelectedIndex()>0);}
		});
    	comboBox_value.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e)
			{textField_value.setEnabled(comboBox_value.getSelectedIndex()>0);}
		});
    	textField_field.setEnabled(comboBox_field.getSelectedIndex()>0);
    	textField_value.setEnabled(comboBox_value.getSelectedIndex()>0);
    	
    	
    	radio_ignoreCase1.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{if(radio_ignoreCase1.isSelected()) radio_ignoreCase2.setSelected(false);}
		});
    	radio_ignoreCase2.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{if(radio_ignoreCase2.isSelected()) radio_ignoreCase1.setSelected(false);}
		});
    }
    
    
    private void init(String display, String code)
    {
    	list_choiceDisplays.add(display);
    	list_choiceCodes.add(code);
    }
    
    
    
    
    
    
    private String findType(StringJComboBox combo)
    {
    	int index = combo.getSelectedIndex();
    	String code = (String) list_choiceCodes.get(index);
    	if(code.equals("ignore")) return code;
    	
    	if(radio_ignoreCase1.isSelected()) return code+"_i";
    	if(radio_ignoreCase2.isSelected()) return code+"_n";
    	return code;
    }
    
    
    
    private JPanel wc(JComponent c1, JComponent c2)
    {
    	JPanel p = new JPanel(new BorderLayout());
    	c2.setBorder(BorderFactory.createEmptyBorder(0,5,0,0));
    	p.add(bordered(c1,0,0,0,10),BorderLayout.WEST);
    	p.add(c2,BorderLayout.CENTER);
    	return p;
    }
    
    
    private JPanel bordered(JComponent c, int top, int left, int bottom, int right)
    {
    	JPanel p = new JPanel(new BorderLayout());
    	p.add(c,BorderLayout.CENTER);
    	p.setBorder(BorderFactory.createEmptyBorder(top, left, bottom, right));
    	return p;
    }
    



    public JComponent gui()
    {return panel;}



    public Object retrieve(String key) throws Exception
    {
    	if(key.equals("scanDir"))
    		return input_dirLabel.provide();
    	if(key.equals("query_entry"))
    		return findType(comboBox_entry)+":"+textField_entry.getText();
    	if(key.equals("query_field"))
    		return findType(comboBox_field)+":"+textField_field.getText();
    	if(key.equals("query_value"))
    		return findType(comboBox_value)+":"+textField_value.getText();
    	
    	if(key.equals("keys")) return new String[]{"scanDir","query_entry","query_field","query_value"};
        throw new Exception("Unknown key: "+key);
    }


}

