package gus05.entity.gus.java.jarinspector.app1.resultgui;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.AbstractTableModel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.ArrayList;



public class ResultGui implements Entity, Give, Execute, Graphic {


    public String getName()				{return "gus.java.jarinspector.app1.resultgui";}
    public String getCreationDate()		{return "2009.02.27";}

    
    public static final int COLUMN_NUMBER = 4;

    
    private Service tableRendering;
    
    private TableModel0 model;
    private JTable table;
    private JPanel panel;
    
    private ArrayList list;




    public ResultGui() throws Exception
    {
    	tableRendering = Outside.service(this,"gus.graphic.table.rendering0");
    	
    	list = new ArrayList();
    	model = new TableModel0();
    	
    	table = new JTable(model);
    	table.setShowGrid(false);
    	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    	table.getTableHeader().setReorderingAllowed(false);
    	
    	tableRendering.register("color",Color.GRAY);
    	tableRendering.register("FILE_jar;FILECONFIG_favorite;DATA_field;DATA_value",table);
    	
    	Outside.service(this,"gus.graphic.table.tooltip").give(table);
    	//Outside.service(this,"gus.graphic.table.sort").give(table);
    	
        panel = new JPanel(new BorderLayout());
        panel.add(new JScrollPane(table),BorderLayout.CENTER);
    }



    public void give(Object obj) throws Exception
    {
    	String line = (String) obj;
    	String[] n = line.split("\t");
    	list.add(n);
    	update();
    }
    
    public void execute() throws Exception
	{
		list.clear();
		update();
	}



    public JComponent gui()
    {return panel;}
    
    
    private synchronized void update()
    {model.fireTableDataChanged();}
    
    
	

    private class TableModel0 extends AbstractTableModel {

		public int getColumnCount() {return COLUMN_NUMBER;}
		public int getRowCount() {return list.size();}
		
		public boolean isCellEditable(int x, int y) {return false;}
		public Class getColumnClass(int y){return String.class;}

		public Object getValueAt(int x, int y)
		{
			String[] n = (String[]) list.get(x);
			return n[y];
		}
    	
		public String getColumnName(int y)
		{
			if(y==0) return "File path";
			if(y==1) return "JAR entry";
			if(y==2) return "key";
			return "value";
		}
    }

}

