package gus05.entity.gus.ling.support.tooltip;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.resources.StringProvider;



public class LingSupportTooltip implements Entity, Give, ActionListener {


    public String getName()				{return "gus.ling.support.tooltip";}
    public String getCreationDate()		{return "2006.11.15";}


    
    private Service lingSupport;
    private StringProvider lingString;
    
    private Vector comps;
    private Vector lings;
    
    
    private String ling(String key)
    {return lingString.getString(key);}
    

    public LingSupportTooltip() throws Exception
    {
        lingSupport = Outside.service(this,"lingSupport");
        lingString = (StringProvider) Outside.resource(this,"lingString");
        lingSupport.addActionListener(this);
        
        comps = new Vector();
        lings = new Vector();
    }



    public void actionPerformed(ActionEvent e)
    {languageChanged();}
    
    
    private void languageChanged()
    {
        for(int i=0;i<comps.size();i++)
        handleComp((JComponent)comps.get(i),(String)lings.get(i));
    }

    
    
    
    
    public void give(Object obj) throws Exception
    {
        if(!(obj instanceof JComponent))
            throw new Exception("Invalid data: "+obj.getClass().getName());
        
        JComponent comp = (JComponent)obj;
        String ling = comp.getToolTipText();
        
        if(comps.contains(comp))
        {
            int index = comps.indexOf(comp);
            comps.remove(index);
            lings.remove(index);
        }
        comps.add(comp);
        lings.add(ling);
        
        handleComp(comp,ling);
    }


    
    private void handleComp(JComponent comp, String key)
    {
        String newText = ling(key);
        comp.setToolTipText(newText);
    }
}

